# -*- coding: cp1252 -*-
# Emmanuel MORAND le 24 janvier 2009
import sys
from PyQt4 import Qt
from PyQt4 import QtGui
from PyQt4 import QtCore
from numpy import*
from random import randint
from time import sleep
import pygame.mixer

  
# dfinition de la classe Fenetre

class Fenetre(QtGui.QWidget):
     
     def __init__(self,parent):
          QtGui.QWidget.__init__(self,parent)
          # cration de la fentre
          self.resize(1000,700)
          self.move((QtGui.QDesktopWidget().availableGeometry().width()-self.geometry().width())/2,(QtGui.QDesktopWidget().availableGeometry().height()-self.geometry().height())/2)
          self.setWindowTitle('Planche de Galton')
          # cration d'un conteneur centr dans la fentre
          self.conteneur=QtGui.QLabel(self)
          self.conteneur.resize(1000,700)
          self.centrerconteneur()
          self.connect(self,QtCore.SIGNAL('Resized()'),self.centrerconteneur)
          
     # centrage du conteneur
     def centrerconteneur(self):
          self.conteneur.move((self.geometry().width()-self.conteneur.geometry().width())/2,(self.geometry().height()-self.conteneur.geometry().height())/2)
          
     # vnement 'Resized()'
     def resizeEvent(self,event):
          self.emit(QtCore.SIGNAL('Resized()'))

# dfinition de la classe Case

class Case(QtGui.QFrame):
     
     def __init__(self,parent):
          QtGui.QFrame.__init__(self,parent)
          self.resize(30,30)
          self.activated=False

     def setActivated(self,activated):
          if (activated or self.activated):
               self.activated=activated
               self.repaint()

     def paintEvent(self,event):
          painter=QtGui.QPainter()
          painter.begin(self)
          painter.setRenderHint(QtGui.QPainter.Antialiasing)
          # trac du clou
          painter.setPen(Qt.QPen(QtCore.Qt.black,1))
          painter.setBrush(QtCore.Qt.black)
          painter.drawEllipse(12,23,6,6)
          # trac de la boule
          if (self.activated):
               painter.setPen(Qt.QPen(QtGui.QColor(120,70,20,255),1))
               gradient=QtGui.QRadialGradient(9,6,12,9,6)
               gradient.setColorAt(0.0,QtCore.Qt.white);
               gradient.setColorAt(1.0,QtGui.QColor(120,70,20,255))
               painter.setBrush(gradient)
               painter.drawEllipse(4,1,22,22)
          painter.end()

# dfinition de la classe Reservoir

class Reservoir(QtGui.QFrame):

     def __init__(self,parent):
          QtGui.QFrame.__init__(self,parent)
          self.resize(24,24)
          self.activated=False
          self.volume=0

     def setActivated(self,activated):
          if (activated or self.activated):
               self.activated=activated
               self.repaint()

     def setVolume(self,volume):
          if (volume!=self.volume):
               self.volume=volume
               self.repaint()

     def paintEvent(self,event):
          painter=QtGui.QPainter()
          painter.begin(self)
          painter.setRenderHint(QtGui.QPainter.Antialiasing)
          # trac de la boule
          if (self.activated):
               painter.setPen(Qt.QPen(QtGui.QColor(120,70,20,255),1))
               gradient=QtGui.QRadialGradient(6,6,12,6,6)
               gradient.setColorAt(0.0,QtCore.Qt.white);
               gradient.setColorAt(1.0,QtGui.QColor(120,70,20,255))
               painter.setBrush(gradient)
               painter.drawEllipse(1,1,22,22)
          else:
               # remplissage du rservoir
               if (0<self.volume<9):
                    #premire et dernires colonnes
                    painter.setPen(Qt.QPen(QtGui.QColor(120,70,20,255),1))
                    painter.setBrush(QtGui.QColor(120,70,20,255))
                    for j in range(24-3*self.volume,24):
                         painter.drawPoint(0,j)
                         painter.drawPoint(19,j)
                         painter.drawPoint(20,j)
                         painter.drawPoint(21,j)
                         painter.drawPoint(23,j)
                    #avant-dernire colonne
                    painter.setPen(Qt.QPen(QtGui.QColor(170,120,70,255),1))
                    painter.setBrush(QtGui.QColor(170,120,70,255))
                    for j in range(24-3*self.volume,24):
                         painter.drawPoint(22,j)
                    #dgrad
                    for i in range(1,19):
                         painter.setPen(Qt.QPen(QtGui.QColor(120+7*(19-i),70+7*(19-i),20+7*(19-i),255),1))
                         painter.setBrush(QtGui.QColor(120+7*(19-i),70+7*(19-i),20+7*(19-i),255))
                         for j in range(24-3*self.volume,24):
                              painter.drawPoint(i,j)
          painter.end()

# dfinition de la classe Compteur

class Compteur(QtGui.QLabel):

     def __init__(self,parent):
          QtGui.QLabel.__init__(self,parent)
          self.setStyleSheet("color:black;font:bold;font-size:15px")
          self.setAlignment(QtCore.Qt.AlignCenter)
          self.value=0
          self.valuemax=0
          self.setText("0 lancer sur 0")

     def setValue(self,value):
          self.value=value
          if (self.value<2):
               self.setText(str(self.value)+" lancer sur "+str(self.valuemax))
          else:
               self.setText(str(self.value)+" lancers sur "+str(self.valuemax))

     def setValueMax(self,value):
          self.valuemax=value
          if (self.value<2):
               self.setText(str(self.value)+" lancer sur "+str(self.valuemax))
          else:
               self.setText(str(self.value)+" lancers sur "+str(self.valuemax))
        
# dfinition de la classe Galton

class Galton(Fenetre):
     
     def __init__(self,parent=None):
          Fenetre.__init__(self,parent)
          pygame.mixer.init()
          pygame.mixer.set_reserved(1)
          # dfinition du nombre de boules total
          self.Nboules=500
          # dfinition du nombre de boules lances
          self.Nbouleslancees=0
          # dfinition de la variable planche, index de la position de la boule sur chacune des lignes (position 0: pas de boule)
          # ...permet en thorie de grer plusieurs boules sur la planche
          self.planche=0*arange(1,10,1)
          # dfinition des sons
          self.son=True
          try:
               pygame.mixer.init()
               self.sontic=pygame.mixer.Sound('sontic.wav')
               self.sontac=pygame.mixer.Sound('sontac.wav')
               self.sontic.set_volume(0.4)
               self.sontac.set_volume(0.8)
          except:
               self.son=False
          # dfinition des 36 cases
          self.case={}
          for i in range(1,9):#numro de ligne
               for j in range(1,i+1):#numro de colonne
                    self.case[i,j]=Case(self.conteneur)
                    self.case[i,j].move(485-17*(i-1)+34*(j-1),50+16*(i-1))
          # trac de la gaussienne
          gaussienne=QtGui.QPixmap(1000,700)
          gaussienne.fill(QtCore.Qt.white)
          painter=QtGui.QPainter()
          painter.begin(gaussienne)
          painter.setRenderHint(QtGui.QPainter.Antialiasing)
          painter.setPen(Qt.QPen(QtGui.QColor(120,70,20,255),3))
          painter.setBrush(QtGui.QColor(120,70,20,255))
          x=range(328,672)
          y=range(0,344)
          for i in range(0,344):
               y[i]=int(659-410*exp(-((x[i]-500)/34.0)**2/4))
          a=x[0]
          b=y[0]
          i=0
          painter.drawPoint(a,b)
          while(i<344):
               if((x[i]-a)**2+(y[i]-b)**2>70):
                    painter.drawPoint(x[i],y[i])
                    a=x[i]
                    b=y[i]
               i=i+1
          painter.end()
          self.conteneur.setPixmap(gaussienne)
          # dfinition des 180+2 rservoirs
          self.reservoir={}
          self.reservoir1=Reservoir(self.conteneur)
          self.reservoir1.move(488,2)
          self.reservoir2=Reservoir(self.conteneur)
          self.reservoir2.move(488,26)
          for i in range(1,20):#numro de ligne
               for j in range(1,10):#numro de colonne
                    self.reservoir[i,j]=Reservoir(self.conteneur)
                    self.reservoir[i,j].move(352+34*(j-1),179+24*(i-1))
          for j in range(1,10):
               self.reservoir[20,j]=Reservoir(self.conteneur)
               self.reservoir[20,j].move(352+34*(j-1),635)
               self.reservoir[20,j].setVolume(-1)
          # dfinition d'une barre de progression
          self.progression=QtGui.QProgressBar(self.conteneur)
          self.progression.setGeometry(40,105,160,15)
          self.progression.setValue(0)
          self.progression.setAlignment(QtCore.Qt.AlignCenter)
          # dfinition d'un label vitesse
          self.labelvitesse=QtGui.QLabel("vitesse",self.conteneur)
          self.labelvitesse.setStyleSheet("color:black;font:bold;font-size:15px")
          self.labelvitesse.setAlignment(QtCore.Qt.AlignCenter)
          self.labelvitesse.setGeometry(800,60,160,40)
          # dfinition d'un label compteur
          self.compteur=Compteur(self.conteneur)
          self.compteur.setGeometry(40,60,160,40)
          self.compteur.setValueMax(self.Nboules)
          self.compteur.setValue(self.Nbouleslancees)
          # dfinition d'un curseur de vitesse
          self.curseurvitesse=QtGui.QSlider(QtCore.Qt.Horizontal,self.conteneur)
          self.curseurvitesse.setGeometry(800,100,160,25)
          self.curseurvitesse.setValue(50)
          # dfinition d'un bouton marche
          self.boutonmarche=QtGui.QPushButton('marche',self.conteneur)
          self.boutonmarche.setGeometry(800,140,50,30)
          self.boutonmarche.connect(self.boutonmarche,QtCore.SIGNAL('clicked()'),self.marche)
          # dfinition d'un bouton pause
          self.boutonpause=QtGui.QPushButton('pause',self.conteneur)
          self.boutonpause.setGeometry(855,140,50,30)
          self.boutonpause.connect(self.boutonpause,QtCore.SIGNAL('clicked()'),self.pause)
          # dfinition d'un bouton arrt
          self.boutonarret=QtGui.QPushButton('arrt',self.conteneur)
          self.boutonarret.setGeometry(910,140,50,30)
          self.boutonarret.connect(self.boutonarret,QtCore.SIGNAL('clicked()'),self.arret)
          # dfinition d'un label son
          self.labelson=QtGui.QLabel("son",self.conteneur)
          self.labelson.setStyleSheet("color:black;font:bold;font-size:15px")
          self.labelson.setAlignment(QtCore.Qt.AlignCenter)
          self.labelson.setGeometry(800,0,160,40)
          # dfinition d'une case  cocher son
          self.checkboxson=QtGui.QCheckBox(self.conteneur)
          self.checkboxson.setGeometry(800,40,160,20)
          self.checkboxson.setStyleSheet("QCheckBox::indicator{subcontrol-position:center}")
          self.checkboxson.setChecked(True)
          self.checkboxson.connect(self.checkboxson,QtCore.SIGNAL('clicked()'),self.mute)
          # dfinition d'un thread
          self.thread=MyThread()
          self.thread.setDelai(50)
          self.connect(self.thread,QtCore.SIGNAL('Lancer1()'),self.lancer1)
          self.connect(self.thread,QtCore.SIGNAL('Lancer2()'),self.lancer2)
          self.connect(self.thread,QtCore.SIGNAL('Lancer3()'),self.lancer3)
          self.connect(self.thread,QtCore.SIGNAL('Deplacement()'),self.deplacement)
          self.connect(self.thread,QtCore.SIGNAL('FinDeplacement()'),self.findeplacement)
          self.connect(self.thread,QtCore.SIGNAL('Remplissage()'),self.remplissage)
          self.connect(self.thread,QtCore.SIGNAL('FinRemplissage()'),self.finremplissage)
          self.connect(self.curseurvitesse,QtCore.SIGNAL('valueChanged(int)'),self.thread.setDelai)

     # dfinition des alertes sonores tic et tac
     def tic(self):
          try:
               if ((self.son)and(self.curseurvitesse.value()<90)):
                    self.sontic.play()
          except:
               self.son=False
     def tac(self):
          try:
               if ((self.son)and(self.curseurvitesse.value()<95)):
                    self.sontac.play()
          except:
               self.son=False

     # dfinition de la fonction hasard (calcule le nouvel tat de la planche aprs un saut de ligne de chacune des boules)
     def hasard(self):
          for i in range(7,-1,-1):
               #remplissage alatoire de la ligne infrieure
               if (self.planche[i]==0):
                    self.planche[i+1]=0
               else:
                    self.planche[i+1]=self.planche[i]+randint(0,1)
          self.planche[0]=0

     # dfinition de la fonction actualisationcases (affiche le nouvel tat de la planche aprs un saut de ligne de chacune des boules)
     def actualisationcases(self):
          for i in range(8,0,-1):
               for j in range(1,i+1):
                    self.case[i,j].setActivated(False)
               if (self.planche[i-1]>0):
                    self.case[i,self.planche[i-1]].setActivated(True)
                    self.tic()

     # dfinition de la fonction actualisationreservoirs (affiche le nouvel tat des rservoirs aprs un saut de ligne de chacune des boules)
     def actualisationreservoirs(self):
          if (0<self.planche[8]<10):
               for ligne in range(19,0,-1):
                    if(self.reservoir[ligne,self.planche[8]].activated):
                         self.reservoir[ligne,self.planche[8]].setActivated(False)
                         if (self.reservoir[ligne+1,self.planche[8]].volume==8):
                              self.tac()
                              self.reservoir[ligne,self.planche[8]].setVolume(1)
                         else:
                              if(self.reservoir[ligne+1,self.planche[8]].volume==-1):
                                   self.tac()
                                   self.reservoir[ligne+1,self.planche[8]].setVolume(1)
                              else:
                                   if (self.reservoir[ligne+1,self.planche[8]].volume==0):
                                        self.reservoir[ligne+1,self.planche[8]].setActivated(True)
                                   else:
                                        self.tac()
                                        self.reservoir[ligne+1,self.planche[8]].setVolume(self.reservoir[ligne+1,self.planche[8]].volume+1)

     # dfinition des fonctions lancer1, lancer2 et lancer3
     def lancer1(self):
          self.reservoir1.setActivated(True)

     def lancer2(self):
          self.reservoir1.setActivated(False)
          self.reservoir2.setActivated(True)

     def lancer3(self):
          self.reservoir2.setActivated(False)
          self.planche[0]=1

     # dfinition de la fonction deplacement

     def deplacement(self):
          self.actualisationcases()
          self.hasard()

     # dfinition de la fonction findeplacement

     def findeplacement(self):
          self.actualisationcases()
          self.reservoir[1,self.planche[8]].setActivated(True)

     # dfinition de la fonction remplissage

     def remplissage(self):
          self.actualisationreservoirs()

     # dfinition de la fonction finremplissage

     def finremplissage(self):
          self.Nbouleslancees=self.Nbouleslancees+1
          self.compteur.setValue(self.Nbouleslancees)
          self.progression.setValue(self.Nbouleslancees*100/self.Nboules)
          if (self.Nbouleslancees==self.Nboules):
               self.thread.paused=True

     # dfinition de la fonction mute
     def mute(self):
          self.son=self.checkboxson.isChecked()

     # dfinition des fonctions marche/pause/arret
               
     def marche(self):
          self.boutonmarche.setFlat(True)
          self.boutonpause.setFlat(False)
          self.boutonarret.setFlat(False)
          if (self.Nbouleslancees<self.Nboules):
               self.thread.reinitialized=False
               self.thread.paused=False

     def pause(self):
          self.boutonmarche.setFlat(False)
          self.boutonpause.setFlat(True)
          self.boutonarret.setFlat(False)
          self.thread.reinitialized=False
          self.thread.paused=True

     def arret(self):
          self.boutonmarche.setFlat(False)
          self.boutonpause.setFlat(False)
          self.boutonarret.setFlat(True)
          self.thread.reinitialized=True
          self.thread.paused=True
          self.Nbouleslancees=0
          self.compteur.setValue(self.Nbouleslancees)
          self.progression.setValue(0)
          self.reservoir1.setActivated(False)
          self.reservoir2.setActivated(False)
          for i in range(0,9):
               self.planche[i]=0
          self.actualisationcases()
          for i in range(1,20):#numro de ligne
               for j in range(1,10):#numro de colonne
                    self.reservoir[i,j].setActivated(False)
                    self.reservoir[i,j].setVolume(0)
          for j in range(1,10):
               self.reservoir[20,j].setVolume(-1)

# dfinition de la classe MyThread

class MyThread(Qt.QThread):
     def __init__(self):
          Qt.QThread.__init__(self)
          self.terminated=False
          self.paused=True
          self.reinitialized=False
          self.delai=1.0#temps de trajet d'une boule en secondes
     def setDelai(self,v):
          self.delai=0.1+15*(1-v/100.0)
     def stop(self):
          self.terminated=True
     def run(self):
          while not(self.terminated):
               if not(self.paused):
                    if not(self.reinitialized):
                         self.emit(QtCore.SIGNAL('Lancer1()'))
                    if not(self.reinitialized):
                         sleep(0.02*self.delai)
                    if not(self.reinitialized):
                         self.emit(QtCore.SIGNAL('Lancer2()'))
                    if not(self.reinitialized):
                         sleep(0.02*self.delai)
                    if not(self.reinitialized):
                         self.emit(QtCore.SIGNAL('Lancer3()'))
                    for i in range(0,8):
                         if not(self.reinitialized):
                              self.emit(QtCore.SIGNAL('Deplacement()'))
                         if not(self.reinitialized):
                              sleep(0.07*self.delai)
                    if not(self.reinitialized):
                         self.emit(QtCore.SIGNAL('FinDeplacement()'))
                    for i in range(0,20):
                         if not(self.reinitialized):
                              self.emit(QtCore.SIGNAL('Remplissage()'))
                         if not(self.reinitialized):
                              sleep(0.01*self.delai)
                    if not(self.reinitialized):
                         self.emit(QtCore.SIGNAL('FinRemplissage()'))
                    if not(self.reinitialized):
                         sleep(0.2*self.delai)
               else:
                    sleep(0.1)

# dfinition de l'application

application=QtGui.QApplication(sys.argv)
fen=Galton()
fen.thread.start()
fen.show()

# lancement de l'application

sys.exit(application.exec_())
